function meanzero, l1, l2, f, ioff, nknot, xknot, yknot, logspl=logspl

;
; Divide flux array by spline
;

;parameters
KNOTNUM = 13 ;total number of knots over the nw pixels
xknot = fltarr(n_elements(f))
yknot = fltarr(n_elements(f))

;copy input array
nw = n_elements(f)
fnorm = f

;First find the range of non-zero data values, nuking edge pixels
l1 = 0
l2 = nw - 1
rrnozero = where(f ne 0,nozero)
if (nozero gt 0) then begin
    l1 = min(rrnozero)
    l2 = max(rrnozero)
    if(l2-l1 lt 3*KNOTNUM) then begin
        print,'MEANZERO: This spectrum is zero!'
        return, -1
    endif
endif else begin
    print,'MEANZERO: This spectrum is zero!'
    return, -1
endelse

;Choose knots for the spline
nknot = 0
kwidth = nw / KNOTNUM
nave = 0
wave = 0
fave = 0
istart = 0
if (ioff gt 0) then istart = calc_modulo(ioff,kwidth) - kwidth
for i=0, nw-1 do begin
    if(i gt l1 and i lt l2) then begin
        nave = nave + 1
        wave = wave + i-0.5
        fave = fave + f[i]
    endif
    if(calc_modulo(i-istart,kwidth) eq 0) then begin
        if(nave gt 0 and fave gt 0) then begin
            xknot[nknot] = wave / nave
            yknot[nknot] = alog10(fave/nave)
            nknot = nknot + 1
        endif
        nave = 0
        wave = 0
        fave = 0
    endif
endfor
if (nknot eq 0) then begin
    print,'MEANZERO: nknot = 0!'
    return, -1
endif  
xknot = xknot[0:nknot-1]
yknot = yknot[0:nknot-1]

;Evaluate the spline at each point, divide and subtract 1
logspl = fltarr(nw)
for i=l1, l2 do begin
    logspl[i] = interpol(yknot,xknot,i-0.5,/spline)
    fnorm[i] = f[i] / 10.^logspl[i] - 1.
endfor

return, fnorm
end
